;=================================================================================================================
; Dictionary.com/Thesaurus.com Word Lookup v1.5 by Shikkie
; Uses nHTMLn.dll by Necroman
;=================================================================================================================
;--- CSS editor

dialog css {
  title "D/T Theme Editor"
  size -1 -1 110 163
  option dbu
  button "", 90, 0 0 0 0, cancel

  box "&Whole Display", 10, 5 5 100 55
  text "BGColor:", 20, 8 15 35 10, right
  text "Font-Family:", 21, 8, 25 35 10, right
  text "Font-Size:", 22, 8 35 35 10, right
  text "Font-Color:", 23, 8 45 35 10, right
  edit "", 1, 55 14 45 10, autohs
  edit "", 2, 55 24 45 10, autohs
  combo 3, 55 34 45 100, drop right
  edit "", 4, 55 45 45 10, autohs

  box "&Links", 12, 5 65 100 45
  text "Decoration: ", 24, 8 75 35 10, right
  text "Font-Color:", 25, 8 85 35 10, right
  text "Hover Color:", 26, 8 95 35 10, right
  combo 5, 55 74 45 50, drop
  edit "", 6, 55 84 45 10, autohs
  edit "", 7, 55 94 45 10, autohs

  box "Readme &Disclaimer", 13, 5 115 100 25

  text "Font-Size:", 27, 8 125 35 10, right
  combo 8, 55 124 45 100, drop right

  button "&Save", 91, 5 145 45 13, ok
  button "&Revert", 92, 60 145 45 13
}
alias css.dlg { dialog -md css css }
;--
on *:dialog:css:init:0: { css.loadfromfile }
on *:dialog:css:sclick:*: {
  if ($did == 91) { css.save }
  if ($did == 92) { css.loadfromfile }
}
alias -l css.loadfromfile { 
  var %css.file = $dict.file(css.css), %css.line
  %css.line = $read(%css.file,n,1)
  var %css.body.bgcolor = $gettok($gettok(%css.line,2,58),1,59)
  var %css.body.fontFamily = $gettok($gettok(%css.line,3,58),1,59)
  var %css.body.fontSize = $gettok($gettok(%css.line,4,58),1,59)
  var %css.body.fontColor = $gettok($gettok(%css.line,5,58),1,59)
  %css.line = $read(%css.file,n,2)
  var %css.links.textDecoration = $gettok($gettok(%css.line,5,58),1,59)
  var %css.links.color = $gettok($gettok(%css.line,6,58),1,59)
  %css.line = $read(%css.file,n,3)
  var %css.links.hover = $gettok($gettok(%css.line,3,58),1,59)
  %css.line = $read(%css.file,n,4)
  var %css.legal.fontSize = $gettok($gettok(%css.line,2,58),1,59)
  ;--
  did -ra css 1 %css.body.bgcolor | did -ra css 2 %css.body.fontFamily | did -ra css 4 %css.body.fontColor | did -ra css 6 %css.links.color | did -ra css 7 %css.links.hover
  var %i = 1
  while (%i <= 30) {
    did -o css 3,8 %i [ %i $+ px ]
    inc %i 1
  }
  did -c css 3 $remove(%css.body.fontSize,px)
  did -c css 8 $remove(%css.legal.fontSize,px)
  did -r css 5
  didtok css 5 32 none underline overline
  var  %i = 1
  while (%i <= $did(css,5).lines) {
    if ($did(css,5,%i) == $right(%css.links.textDecoration,-1)) { did -c css 5 %i | break }
    inc %i 1
  }
}
alias -l css.save {
  var %css.file = $dict.file(css.css), %css.line
  .write -c %css.file BODY, BODY * $chr(123) background: $did(css,1) $+ ;   font-face: $did(css,2) $+ ; font-size: $did(css,3) $+ ;  color: $did(css,4) $+ ; $chr(125)
  .write %css.file A:link, A:visited, A:active $chr(123) text-decoration: $did(css,5) $+ ; color: $did(css,6) $+ ; $chr(125)
  .write %css.file a:hover $chr(123) color: $did(css,7) $+ ; $chr(125)
  .write %css.file .legal, .legal * $chr(123) font-size: $did(css,8) $+ ; $chr(125)
  if ($dialog(d).title !== $null) { dict.dll refresh | dialog -v d }
}
;;;;;;;;;;;;;===============================

alias -l dict.dll { if ($isid) { return $dll($scriptdirnHTMLn.dll,$$1,$2-) } | else { dll $scriptdirnHTMLn.dll $$1 $2- } }
alias -l dict.file { return $scriptdir $+ $1- }
alias -l dict.doSearch { 
  set %dict.type $$1
  dict.status Performing $$1 search on ' $+ $did(d,1) $+ '...  
  set %dict.lastword $did(d,1) | .unset %dict.doread %dict.found
  sockopen dict $iif($$1 == dictionary,dictionary.com,thesaurus.com) 80 
  set %dict.file $dict.file(res.htm) 
  .write -c %dict.file <html><head><title> $+ $$1 $+ com Search by Shikkie</title> $+ $crlf $+ <link rel=stylesheet type=text/css href=css.css></head> $+ $crlf $+ <body><center><b> $+ $$1 $+ .com Word Lookup v $+ $dict.version by Shikkie</b></center><hr><br> 
}
alias -l dict.dispResult { if (%dict.type == Thesaurus && %dict.found !== $true) { .write %dict.file No matches found for <b> $+ $did(d,1) $+ .</b> } | .write %dict.file $crlf $+ </body></html> | if ($right($dict.dll(url),7) == res.htm) { dict.dll refresh } | else { dict.dll navigate $dict.file(res.htm) } | dict.status Done. }
alias -l dict.version { return 1.5 }
alias -l dict.quickSearch { dict.dlg | did -ra d 1 $2- | dict.doSearch $$1 } 
alias -l dict.status { did -ra d 2 $1- }
;========
on *:sockopen:dict: {  
  if (%dict.type == dictionary) sockwrite -n dict GET /cgi-bin/dict.pl?term= $+ $did(d,1)
  else {
    sockwrite -n dict GET /cgi-bin/search?config=roget&words= $+ $did(d,1)
  }
}
on *:sockclose:dict: { if (%dict.doread !== $true && $dialog(d) !== $null) { dict.dispResult } }
on *:sockread:dict:{
  if ($sockerr > 0) return
  :nextread
  sockread %temp 
  if (%temp == $null) set %temp $crlf
  if ($sockbr == 0) { return }
  if (%dict.doread == $true) { write %dict.file %temp }
  if (No entry found for isin %temp) { .unset %dict.doread }
  if (%temp == <!-- resultListStart -->) { set %dict.doread $true | set %dict.found $true }
  if (%temp == <!-- resultListEnd -->) { .unset %dict.doread }
  goto nextread
}
;========
dialog d {
  size -1 -1 250 240
  title "x"
  option dbu
  text "Search &Term:", 100, 10 5 40 12
  edit %dict.lastword, 1, 50 4 75 10
  button "&Dictionary", 91, 130 5 35 10
  button "&Thesaurus", 93, 170 5 35 10
  button "&Cfg Display", 96, 170 17 35 10
  button "&Help", 92, 210 17 35 10
  button "&Results", 94, 210 5 35 10
  text "", 2, 10 17 155 10
  box "RES_WIN", 5, 5 29 240 206
  button "", 90, 0 0 0 0, cancel
}
alias dict.dlg { dialog -md d d }
on *:dialog:d:init:0: { dialog -t d Dictionary.com/Thesaurus.com Word Lookup v $+ $dict.version by Shikkie | set %dict.hwnd $dict.dll(find,RES_WIN) | dict.dll attach %dict.hwnd | dict.dll navigate $dict.file(readme.htm) | dict.status Ready }
on *:dialog:d:sclick:*: {
  if ($did == 91) { dict.doSearch Dictionary }
  if ($did == 92) { dict.dll navigate $dict.file(readme.htm) | dict.status Opening Help.... }
  if ($did == 93) { dict.doSearch Thesaurus }
  if ($did == 94) { dict.dll navigate $dict.file(res.htm) | dict.status RE-Opening %dict.type results for '  $+ $did(d,1) $+ ' } 
  if ($did == 96) { css.dlg }
}
menu menubar,channel,status {
  -
  &Dictionary/ThesaurusSearch v $+ $dict.version
  .&Open:dict.dlg
  . $+ $iif($numtok($cb,32) == 1,&Quick Search < $+ $cb $+ >)
  ..&Dictionary:dict.quickSearch Dictionary $cb
  ..&Thesaurus:dict.quickSearch Thesaurus $cb
  .-
  .&Config Display:css.dlg
  .-
  .&Unload
  ..&Yes I'm sure
  ...&Do it!:unload -rs $script
}
;@
